/*
 * El_Pot_Ovl.c
 *
 * Created: 17.5.2016 7:09:06
 *  Author: Petr
 */ 

//#include <avr/io.h>  //toto se sem asi vlozilo pri zalozeni projektu ... na teto urovni programu to neni  potreba
#include <avr/pgmspace.h>

//tyto texty nejsou nikde v programu vyuzite, ale slouzi jako
//identifikace programu, viditelna ve vypisu programove pameti
char id1[] PROGMEM = "Program pro ovladani elektronickeho potenciometru MCP4262\n";
char id2[] PROGMEM = "Soubor: "__FILE__"\n";
char id3[] PROGMEM = "Datum: "__DATE__"\n";
char id4[] PROGMEM = "Cas: "__TIME__"\n";




#include "macros.h" //Makra pro manipulaci s bity a bajty apod, zde by nemelo byt potreba, veskere fyzicke pristupy jsou pres knihovny

#include "sw_ovl_spi.h"  // Ovladani sbernice SPI, momentalne softwareove, ale nemel by byt problem nahradit to hw knihovnou

//#include "sw_ovl_spi.c"  //PORAD TO NEUMIM tak abych nemusel vkladat soubor .c a nechce se mi tahat herouta (takto je to spatne, melo by stacit includovat pouze .h)
							//uz se povedlo ale porad si myslim, ze nekorektne


// vychozi nastaveni RC oscilator 8 MHz deleny osmi (tj. 1 MHz), mozna to bude i stacit
# define F_CPU     1000000UL


// nasledujici definice a funkce presunu do nove knihovny (pojmenovane napr. Elpot.h/c), zatim jsou zde
#define MCP_ADDR_Volatile_Wiper0    0
#define MCP_ADDR_Volatile_Wiper1    1
#define MCP_ADDR_NonVolatile_Wiper0 2
#define MCP_ADDR_NonVolatile_Wiper1 3
#define MCP_ADDR_TCON               4
#define MCP_ADDR_STATUS             5
#define MCP_ADDR_DATA_EEPROM        6 //zacatek pameti eeprom (10 devitibitovych slov) pro libovolne pouziti

#define MCP_CMD_Read_Data  0b11
#define MCP_CMD_Write_Data 0b00
#define MCP_CMD_Increment  0b01
#define MCP_CMD_Decrement  0b01


uint8_t LogTable[64] PROGMEM = //
 {//prevodni tabulka pro regulaci hlasitosti - vybrana jsou cisla tak aby prubeh byl logaritmicky
  //pocatek je strmejsi, ale potom je konstantni krok priblizne 0,665 dB (toto cislo vedlo prave na 64 kroku od 0 do 255) v rozsahu cca 45 dB (1/255 pu)
  //....\Konstrukce\El_Pot\Elektronick_potenciometr_nvrh_1(2).ods
       0,   1,   2,   3,   4,   5,   6,   7,
       8,   9,  10,  11,  12,  13,  14,  15,
      16,  17,  18,  19,  20,  22,  24,  26,
      28,  30,  32,  34,  36,  38,  40,  43,
      46,  49,  52,  55,  58,  62,  66,  70,
      74,  78,  83,  88,  93,  98, 104, 110,
     116, 123, 130, 137, 145, 153, 161, 170,
     179, 189, 199, 210, 221, 233, 246, 255
 };

uint16_t _mcp42_16bit_RW (uint8_t adresa, uint8_t prikaz, uint16_t data)
{
	uint16_t hodnota_odesl = ((adresa & 0xf)<<12) | ((prikaz & 3)<<10) | (data & 0x1FF);
	//uint16_t hodnota_prijem = SPI_Exchange_Word(hodnota_odesl);
	SPI_Send_Word(hodnota_odesl);
	//return hodnota_prijem;
	return 0;
}

void nastavpot_N(uint8_t ktery, uint16_t pozice)
{//nastavi hodnotu vybraneho bezce (0 nebo 1) zapisem do RAM obvodu mpc42xx
	//je moznych celkem 257 hodnot od 0 do 256
	if (pozice>0x100) {pozice = 0x100;} //prime pripojeni na vstup, vyssi pozice nema smysl, i kdyz neni zakazana, znamena totez* jako 0x100
		                                // *pro vyssi hodnoty nefunguje prikaz decrement  
	_mcp42_16bit_RW(ktery & 1, MCP_CMD_Write_Data, pozice);
}

void nastavpot_G(uint8_t ktery,  uint16_t pozice)
{//nastavi hodnotu vybraneho bezce (daneho argumentem "ktery") na logaritmicke stupnici od 0 do 63 plus 64 pro nejvyssi hodnotu
	//v budoucnu asi tuto moznost uberu a plna hodnota bude uz na 63 (toto cislo jenom nebylo mozne ulozit do osmibitove tabulky, misto nej je tam 255)
	if (pozice>63) //posledni polozka v tabulce neni, prakticky je mozne pouzit 65 polozek, vyssi jsou ignorovany, nahrazeny posledni hodnotou
	    {pozice = 0x100;} 
		else {pozice = 	pgm_read_byte(&(LogTable[pozice]));}
	nastavpot_N(ktery,pozice);		
}


void nastavpot(uint8_t hodnota)
{
	//uint16_t hodnota_odesl = 0x1300 | hodnota;//cislo k odeslani, prikaz=zapis, target=oba ... toto bude dobre dodefinovat 
	uint16_t hodnota_odesl = 0x0000 | hodnota;//cislo k odeslani, adresa0=jezdecA-RAM prikaz0=zapis ... toto bude dobre dodefinovat 
	SPI_Send_Word(hodnota_odesl);
}

#define EP_PLUS  C,5
#define EP_MINUS C,4





int main(void)
{
    SPI_Init();//inicializace pin rozhrani
		   nastavpot_N(1,0);//vychozi stav obou bezcu
		   nastavpot_N(0,0);
    while(1)
    {
        //TODO:: Please write your application code 
//		for (uint8_t k=255;k;k--)
		for (uint8_t k=0;;)//nekonecny cyklus
		{
		   //nastavpot(k);
		   if ((k>0)&&(GET(EP_MINUS)))
		   {
		      k--;
		   }
		   else
		   {
			   if ((k<255)&&(GET(EP_PLUS)))
			   {
				   k++;
			   } 
			   else
			   {
    			   continue;//zadna zmena, zbytek lze preskocit
			   }
		   }
		   nastavpot_N(1,k);
		   nastavpot_G(0,k>>2);
		   _delay_ms(100);
		}
    }
}