#ifndef __MACROS__
#define __MACROS__

/*
Makra pro manipulaci s bity a bajty apod + dalsi univerzalni veci co se nikam jinam nehodily
bits, nibbles and bajts macros and other multipurpose macros not passing otherwise
*/



#define GLUE(a, b)     a##b


/* nibble macros, used for data path */
#define ASSIGN_(what, p, m, v) GLUE(what, p) = (GLUE(what, p) & \
						~((1 << (m)) | (1 << ((m) + 1)) | \
						  (1 << ((m) + 2)) | (1 << ((m) + 3)))) | \
					        ((v) << (m))
#define ASSIGNB_(what, p, m, v) GLUE(what, p) = v
#define READ_(what, p, m) (GLUE(what, p) & ((1 << (m)) | (1 << ((m) + 1)) | \
					    (1 << ((m) + 2)) | (1 << ((m) + 3)))) >> (m)
#define READB_(what, p, m) (GLUE(what, p))
#define ASSIGN(what, x, v) ASSIGN_(what, x, v)
#define ASSIGNB(what, x, v) ASSIGNB_(what, x, v)
#define READ(what, x) READ_(what, x)
#define READB(what, x) READB_(what, x)



















/* single-bit macros, used for control bits */
#define GLUE(a, b)     a##b
#define SET_(what, p, m) GLUE(what, p) |= (1 << (m))
#define CLR_(what, p, m) GLUE(what, p) &= ~(1 << (m))
#define BIT_(what, p, m, h) ((h)?(GLUE(what, p) |= (1 << (m))):((GLUE(what, p)) &= ~(1 << (m))))
#define GET_(/* PIN, */ p, m) GLUE(PIN, p) & (1 << (m))
#define SET(what, x) SET_(what, x)
#define CLR(what, x) CLR_(what, x)
#define BIT(what, x, h) BIT_(what, x, h)
#define GET(/* PIN, */ x) GET_(x)
//BYTE MACROS
#define ASSIGNB_(what, p, m, v) GLUE(what, p) = v
#define ASSIGNB(what, x, v) ASSIGNB_(what, x, v)
#define READB_(what, p, m) (GLUE(what, p))
#define READB(what, x) READB_(what, x)


//no operation to realize small delay etc.
#define _NOP() __asm__ __volatile__("nop")
//osmkrat NOP pro vetsi nez mala zpozdeni
#define _NOP8() _NOP();_NOP();_NOP();_NOP();_NOP();_NOP();_NOP();_NOP()  

#define SREG	_SFR_IO8(0x3F)  //stavovy registr, tato definice neni v avrio.h; this definition isnt contained in avrio.h
#define I	    7               //pozice Interrupt flagu v SREG

//interrupt flag backup and restore macros
#define SAVE_I_FLAG(kam) 	if (kam = (SREG & (1<<I))) 	cli();
#define RESTORE_I_FLAG(kam)	if (kam) sei();




#endif



