// sofwareova implementace SPI protokolu

#include "sw_ovl_spi.h"
#include "macros.h"
#include <util/delay.h>

#define SETP(P) SET_(PORT,P)
#define CLRP(P) CLR_(PORT,P)


#define DATA(D) BIT(PORT,SPI_DATA,D)
#define GETDATA (GET(SPI_DATA_IN))

#define Clock_unset() CLRP(SPI_SCK)
#define Clock_set() SETP(SPI_SCK)
#define Slave_Select() CLRP(SPI_SS)
#define Slave_unSelect() SETP(SPI_SS)

void SPI_Init()
{
	// Inicializace I/O pin avr
	SETP(SPI_SCK);//
	CLRP(SPI_DATA);//
	SETP(SPI_SS);//
	// Prislusne signaly jako vystup
	SET(DDR,SPI_SCK);//
	SET(DDR,SPI_DATA);//
	SET(DDR,SPI_SS);//
	// SDI jako vstup (nebudu se spolehat na defaultni nastaveni, uzivatel ho mohl zmenit pred zavolanim teto funkce)
	CLR(DDR,SPI_DATA_IN);
}


void SPI_Send_Word (uint16_t slovo)
{
	// chip select
	Slave_Select();
    _NOP();
	for (uint16_t i = 0x8000;i;i>>=1)
	{
  	  	Clock_unset();// nastavi SCK na nulu
      // data se zapisuji na nabeznou hranu hodin
      DATA(slovo & (i));// vysilani bitu od nejvyssiho k nejnizsimu
        _NOP8();//to je prehnane, ani kdyby tu nebyl zadny nop, ochranne doby se nepodari prekonat
	  //hodiny na 1
	    Clock_set();
	  //prodleva SCK=1
	    _NOP8();
	  //shodit hodiny
    	//Clock_unset();// nastavi SCK na nulu
	    _NOP8();
	}
    _NOP8();
	Slave_unSelect();
	_NOP();
	    //Clock_set();//nevim, jestli toto nema byt v opacnem poradi
	DATA(0);//neni nutne, ale na osciloskopu to pak vypada lepe
}



uint16_t SPI_Exchange_Word (uint16_t slovo)
{
     uint16_t cteni = 0;
 //	Clock_idle();// nastavi SCK na nulu
	_NOP8();
	// chip select
	Slave_Select();
	Clock_unset();// nastavi SCK na nulu
	for (uint16_t i = 0x8000;i==1;i>>=1)
	{
  	  // data se zapisuji na nabeznou hranu hodin
      DATA(slovo & (i));// vysilani bitu od nejvyssiho k nejnizsimu
        _NOP8();
	  //a ctou se na sestupnou hranu (tesne pred ni)
	    if (GETDATA) cteni |= i;
	  //hodiny na 1
	    Clock_set();
	  //prodleva SCK=1
	    _NOP8();
	  //shodit hodiny
    	Clock_unset();// nastavi SCK na nulu
	    _NOP8();
	}
    _NOP8();
	Slave_unSelect();
	_NOP();
	    Clock_set();
	DATA(0);
return cteni;
}





